unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  LCLintf, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
     Label1: TLabel;
     lblDragText: TLabel;
    Panel1: TPanel;
    procedure FormCreate(Sender: TObject);
    procedure Label1MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure Label1MouseUp  (Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure Label1MouseMove(Sender: TObject;                       Shift: TShiftState; X, Y: Integer);
  private
    FDownPoint: TPoint;
    ptPanel: TPoint;
    FDragging: Boolean;
    FAllowDrag: Boolean;
  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  FAllowDrag := True;
  lblDragText.Visible := False;
end;

procedure TForm1.Label1MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if (Button = mbLeft) then begin
      FDragging := True;
      lblDragText.Top     := Label1.Top;
      lblDragText.Left    := Label1.Left;
      lblDragText.Width   := Label1.Width;
      lblDragText.Height  := Label1.Height;
      lblDragText.Caption := Label1.Caption;
      lblDragText.Visible := True;
      FDownPoint.X := X;
      FDownPoint.Y := Y;
    end;
end;

procedure TForm1.Label1MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
var MovePoint : TPoint;
begin
  if FDragging and FAllowDrag then begin
      MovePoint.X      := X + Label1.Left;
      MovePoint.Y      := Y + Label1.Top;
      lblDragText.Left := MovePoint.X - FDownPoint.X;
      lblDragText.Top  := MovePoint.Y - FDownPoint.Y;
      if (ptinrect (Panel1.BoundsRect, MovePoint)) then lblDragText.Font.Color:=clLime
      else lblDragText.Font.Color:=clRed;
    end;
end;

procedure TForm1.Label1MouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if Button = mbLeft then
    FDragging := False;
  lblDragText.Visible := False;
end;

end.

